"use strict";
/*
 * Copyright 2019 Quadrant LLC. (http://quadrant.agency/)
 *
 * This file is part of Quadrant Transit.
 *
 * Quadrant Transit is distributed without license for evaluation purposes only.
 */
Object.defineProperty(exports, "__esModule", { value: true });
var IdentityDriverBase = /** @class */ (function () {
    function IdentityDriverBase() {
    }
    IdentityDriverBase.prototype.obtainCredentials = function (request) {
        return Promise.resolve(request.headers["x-transit-authorization"] || null);
    };
    IdentityDriverBase.prototype.obtainIdentity = function (request, response) {
        return Promise.resolve(null);
    };
    IdentityDriverBase.prototype.identityCredentials = function (credentials) {
        // in most auth modules, this will never get called
        throw new Error("not implemented");
    };
    IdentityDriverBase.prototype.configureFailureResponse = function (response) {
        response.statusCode = 401;
    };
    return IdentityDriverBase;
}());
exports.IdentityDriverBase = IdentityDriverBase;
function loadIdentitySource(config) {
    var driverPath = config.driver.match(/^[\w\d]+$/) ? __dirname + "/identity/" + config.driver : config.driver;
    return require.main.require(driverPath).createDriver(config.config);
}
exports.loadIdentitySource = loadIdentitySource;
