"use strict";
/*
 * Copyright 2019 Quadrant LLC. (http://quadrant.agency/)
 *
 * This file is part of Quadrant Transit.
 *
 * Quadrant Transit is distributed without license for evaluation purposes only.
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var log = require("./Logger");
var OperationNotifier = /** @class */ (function () {
    function OperationNotifier() {
        var resolver = null;
        var rejecter = null;
        this.promise = new Promise(function (resolve, reject) {
            resolver = resolve;
            rejecter = reject;
        });
        this.resultHandler = function (result) { resolver && resolver(result); };
        this.errorHandler = function (error) { rejecter && rejecter(error); };
    }
    OperationNotifier.prototype.sendResult = function (r) {
        this.resultHandler(r);
        this._clearHandlers();
    };
    OperationNotifier.prototype.sendError = function (err, debugInfo) {
        log.error("Execution failed with error:\n--- start of error\n" + err.stack + "\n--- end of error\n" + (debugInfo ? "Debug info: " + debugInfo : ''));
        this.errorHandler(err);
        this._clearHandlers();
    };
    OperationNotifier.prototype.cancel = function () {
        this._clearHandlers();
    };
    OperationNotifier.prototype._clearHandlers = function () {
        this.resultHandler = function (r) { };
        this.errorHandler = function (e) { };
    };
    return OperationNotifier;
}());
exports.OperationNotifier = OperationNotifier;
var DatabaseResultNotifier = /** @class */ (function (_super) {
    __extends(DatabaseResultNotifier, _super);
    function DatabaseResultNotifier() {
        return _super.call(this) || this;
    }
    /*
    sendColumns(c : Columns) {}
    sendRows(r : Row[]) {}
    sendComplete() {}
    */
    DatabaseResultNotifier.prototype._clearHandlers = function () {
        _super.prototype._clearHandlers.call(this);
    };
    return DatabaseResultNotifier;
}(OperationNotifier));
exports.DatabaseResultNotifier = DatabaseResultNotifier;
