declare type APISuccessResponse = import("../Result").APISuccessResponse;
declare type APIErrorResponse = import("../Result").APIErrorResponse;
declare type DatabaseResult = import("../Result").DatabaseResult;
declare type DataSourceHierarchy = import("../DataSource").DataSourceHierarchy;
declare type EntitySpec = import("../Command").EntitySpec;
declare type ParameterSpec = import("../Command").ParameterSpec;
declare namespace Transit {
    type EntityRef = string;
    type EntityOptions = {
        ref?: string;
        wait?: boolean;
        single?: boolean;
        args?: Object;
        onload?: Function;
        onerror?: Function;
    };
    type EntityMeta = {
        args: Object;
        unused: boolean;
        underway: boolean;
        complete: boolean;
        error: string;
    };
    type BatchEntry = [string, Object];
    type RequestSpec = {
        ref: EntityRef;
        resolve?: Function;
        reject?: Function;
    };
    function loadNamespace(ns: string): Promise<Namespace>;
    class Namespace {
        name: string;
        api: DataSourceHierarchy;
        entities: {
            [key: string]: Entity;
        };
        loadRequests: RequestSpec[];
        vue: any;
        constructor(name: string, api: DataSourceHierarchy);
        entity(name: string, options?: EntityOptions | string): Entity;
        vueMixin(): any;
        load(ref: EntityRef): Promise<any>;
        save(ref: EntityRef): Promise<any>;
        scheduleLoadRequest(ref: EntityRef): Promise<any>;
        processLoadRequests(): Promise<void>;
    }
    class Entity {
        URLName: string;
        spec: EntitySpec;
        options: EntityOptions;
        meta: EntityMeta;
        loadRequested: boolean;
        saveRequested: boolean;
        onload?: Function;
        onerror?: Function;
        constructor(URLName: string, spec: EntitySpec, options: EntityOptions);
        loadOp(): string;
        parameterSpecs(): ParameterSpec[];
        makeLoadBatchItem(): BatchEntry;
    }
    function callServer(path: string, args?: Object, authToken?: string): Promise<APISuccessResponse | APIErrorResponse>;
    function isSuccess(response: APISuccessResponse | APIErrorResponse): response is APISuccessResponse;
    function delay(ms: number): Promise<{}>;
}
