var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var Transit;
(function (Transit) {
    function loadNamespace(ns) {
        return __awaiter(this, void 0, void 0, function () {
            var response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Transit.callServer(ns + ".json")];
                    case 1:
                        response = _a.sent();
                        if (Transit.isSuccess(response)) {
                            return [2 /*return*/, Transit['$' + ns] = new Namespace(ns, response.data)];
                        }
                        else {
                            throw new Error(response.errors[0].detail);
                        }
                        return [2 /*return*/];
                }
            });
        });
    }
    Transit.loadNamespace = loadNamespace;
    var Namespace = /** @class */ (function () {
        function Namespace(name, api) {
            this.entities = {};
            this.loadRequests = [];
            this.vue = null;
            this.name = name;
            this.api = api;
        }
        Namespace.prototype.entity = function (name, options) {
            if (typeof options != "object") {
                options = {};
            }
            if (!options.ref) {
                options.ref = name;
            }
            if (this.entities[options.ref]) {
                return this.entities[options.ref];
            }
            else if (!this.api[name]) {
                throw new Error("Transit: entity not found: " + name);
            }
            else {
                return this['$' + options.ref] = this.entities[options.ref] = new Entity(name, this.api[name], options || {});
            }
        };
        Namespace.prototype.vueMixin = function () {
            var data = {};
            var watch = {};
            for (var ref in this.entities) {
                var entity = this.entities[ref];
                data[ref] = [];
                data[ref + "Meta"] = entity.meta;
                watch[ref + "Meta.args"] = {
                    handler: (function (ref) { return (function () { return _ns.load(ref); }); })(ref),
                    deep: true
                };
                if (!entity.options.wait) {
                    this.load(ref);
                }
            }
            var _ns = this;
            return {
                data: data,
                watch: watch,
                created: function () {
                    _ns.vue = this;
                }
            };
        };
        Namespace.prototype.load = function (ref) {
            return this.scheduleLoadRequest(ref);
        };
        Namespace.prototype.save = function (ref) {
            throw new Error("Not implemented");
        };
        Namespace.prototype.scheduleLoadRequest = function (ref) {
            var entity = this.entities[ref];
            if (!entity) {
                throw new Error("Transit: entity not found: " + ref);
            }
            entity.loadRequested = true;
            entity.meta.unused = false;
            entity.meta.underway = true;
            entity.meta.complete = false;
            entity.meta.error = "";
            var entry = { ref: ref };
            this.loadRequests.push(entry);
            this.processLoadRequests();
            return new Promise(function (resolve, reject) {
                entry.resolve = resolve;
                entry.reject = reject;
            });
        };
        Namespace.prototype.processLoadRequests = function () {
            return __awaiter(this, void 0, void 0, function () {
                var batch, _i, _a, request, entity, requests, response, e_1, i, entity, result, outRows, _b, _c, inRow, outRow, j, entity_1, returned;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0: 
                        // don't schedule multiple requests,
                        // and make sure to bundle all requests in an execution
                        // cycle into one batch.
                        return [4 /*yield*/, delay(1)];
                        case 1:
                            // don't schedule multiple requests,
                            // and make sure to bundle all requests in an execution
                            // cycle into one batch.
                            _d.sent();
                            if (this.loadRequests.length == 0) {
                                return [2 /*return*/];
                            }
                            batch = [];
                            for (_i = 0, _a = this.loadRequests; _i < _a.length; _i++) {
                                request = _a[_i];
                                entity = this.entities[request.ref];
                                if (entity.loadRequested) {
                                    batch.push(entity.makeLoadBatchItem());
                                    entity.loadRequested = false;
                                }
                            }
                            requests = this.loadRequests;
                            this.loadRequests = [];
                            _d.label = 2;
                        case 2:
                            _d.trys.push([2, 4, , 5]);
                            return [4 /*yield*/, callServer(this.name + "/$batch-api", batch)];
                        case 3:
                            response = _d.sent();
                            return [3 /*break*/, 5];
                        case 4:
                            e_1 = _d.sent();
                            response = { errors: [{ status: -1, detail: String(e_1) }], meta: { batchIndex: 0 } };
                            return [3 /*break*/, 5];
                        case 5:
                            for (i = 0; i < requests.length; i++) {
                                entity = this.entities[requests[i].ref];
                                entity.meta.underway = false;
                                entity.meta.complete = true;
                                if (isSuccess(response)) {
                                    result = response.data[i];
                                    outRows = [];
                                    for (_b = 0, _c = result.rows; _b < _c.length; _b++) {
                                        inRow = _c[_b];
                                        outRow = {};
                                        for (j = 0; j < result.columns.length; j++) {
                                            outRow[result.columns[j].spec.name] = inRow[j];
                                        }
                                        outRows.push(outRow);
                                    }
                                    outRows["columns"] = result.columns;
                                    entity_1 = this.entities[requests[i].ref];
                                    returned = entity_1.options.single ? outRows[0] || {} : outRows;
                                    this.vue[requests[i].ref] = returned;
                                    entity_1.meta.error = "";
                                    if (entity_1.onload)
                                        entity_1.onload(returned);
                                    if (requests[i].resolve)
                                        requests[i].resolve(returned);
                                }
                                else {
                                    if (!response.meta || typeof response.meta.batchIndex != "number" || i == response.meta.batchIndex) {
                                        if (requests[i].reject)
                                            requests[i].reject(response.errors[0].detail);
                                    }
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return Namespace;
    }());
    var Entity = /** @class */ (function () {
        function Entity(URLName, spec, options) {
            this.loadRequested = false;
            this.saveRequested = false;
            this.URLName = URLName;
            this.spec = spec;
            this.options = options;
            this.meta = {
                args: options.args || {},
                unused: true,
                underway: false,
                complete: false,
                error: ""
            };
            this.onload = options.onload;
            this.onerror = options.onerror;
            var params = this.parameterSpecs();
            for (var i = 0; i < params.length; i++) {
                var pname = params[i].spec.name;
                // make our properties reactive
                if (this.meta.args[pname] === undefined) {
                    this.meta.args[pname] = undefined;
                }
            }
        }
        Entity.prototype.loadOp = function () {
            return this.spec.operations.select ? "select" : "call";
        };
        Entity.prototype.parameterSpecs = function () {
            return this.spec.operations[this.loadOp()].parameters;
        };
        Entity.prototype.makeLoadBatchItem = function () {
            var outArgs = [];
            var params = this.parameterSpecs();
            for (var i = 0; i < params.length; i++) {
                var val = this.meta.args[params[i].spec.name];
                if (typeof val == "function") {
                    val = val.call();
                }
                outArgs.push(val);
            }
            return [this.URLName + "." + this.loadOp(), outArgs];
        };
        return Entity;
    }());
    function callServer(path, args, authToken) {
        return new Promise(function (resolve, reject) {
            var oXHR = new XMLHttpRequest();
            oXHR.open("POST", "/v1/" + path, true);
            oXHR.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
            if (authToken) {
                oXHR.setRequestHeader("x-transit-authorization", authToken);
            }
            oXHR.onreadystatechange = function (oEvent) {
                if (this.readyState === 4) {
                    var json = void 0;
                    try {
                        json = JSON.parse(this.responseText);
                    }
                    catch (e) {
                        reject(new Error(this.responseText));
                        return;
                    }
                    resolve(json);
                }
            };
            oXHR.send(JSON.stringify(args || []));
        });
    }
    Transit.callServer = callServer;
    ;
    function isSuccess(response) {
        return response.data != null;
    }
    Transit.isSuccess = isSuccess;
    function delay(ms) {
        return new Promise(function (resolve) { return setTimeout(resolve, ms); });
    }
    Transit.delay = delay;
})(Transit || (Transit = {}));
